->
-> ANNVIT CPTIS MDCCLXXVI!
->
->      KRSNAke v1.8 exp
->
-> $NSAREG: 23F07N07OR2748D5944.7 [Crassus]
->
-> Copyright  1995 Psilocybe Software
->
-> This program is free software; you can redistribute it and/or modify
-> it under the terms of the GNU General Public License as published by
-> the Free Software Foundation; either version 2 of the License, or
-> (at your option) any later version.
->
-> This program is distributed in the hope that it will be useful,
-> but WITHOUT ANY WARRANTY; without even the implied warranty of
-> MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-> GNU General Public License for more details.
->
-> You should have received a copy of the GNU General Public License
-> along with this program; if not, write to the Free Software
-> Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
->
-> $HISTORY:
->
-> 22 Sep 1995 : 001.008 :  Now is a commodity, can appear/disappear
-> 19 Sep 1995 : 001.007 :  Added ARexx port and cleaned up imsg handling
-> 10 Sep 1995 : 001.006 :  Uses new prefs system and datatype backgrounds
-> 12 Jul 1995 : 001.005 :  Uses krsnake.library instead of internal c/s code
-> 11 Jul 1995 : 001.004 :  Autostarts clients
-> 07 Jul 1995 : 001.003 :  Now sends SNAKE_MOVES event to clients
-> 27 Jun 1995 : 001.002 :  Added client/server interface
-> 23 Jun 1995 : 001.001 :  Initial revision
->
-> NOVUS ORDO SECLORUM!
->

OPT OSVERSION=37
OPT PREPROCESS

MODULE 'intuition/intuition','intuition/screens','dos/dos','graphics/text'
MODULE 'graphics/view','datatypes/datatypes','datatypes/datatypesclass'
MODULE 'datatypes/soundclass','datatypes','exec/execbase','exec/lists','utility'
MODULE 'exec/semaphores','exec/nodes','dos/dostags','exec/libraries','dos/dosextens'
MODULE 'krsnake','libraries/krsnake','tools/arexx','tools/trapguru','exec/ports'
MODULE 'libraries/lowlevel','lowlevel','datatypes/pictureclass','graphics/gfx'
MODULE 'commodities','libraries/commodities','tools/ports','amigalib/cx'
MODULE 'wb','icon','workbench/workbench'

MODULE '*tiledbitmap'

RAISE   "SCR"   IF  LockPubScreen()=0,
        "WIN"   IF  OpenWindowTagList()=0,
        "DRI"   IF  GetScreenDrawInfo()=0,
        "FONT"  IF  OpenFont()=0,
        "DOBJ"  IF  AllocDosObject()=0,
        "LSEG"  IF  LoadSeg()=0,
        "CXBR"  IF  CxBroker()=0,
        "PORT"  IF  CreateMsgPort()=0

#define KRSNAKEVER {krsnakever}+6

DEF krs=0
DEF w=0:PTR TO window,s=0:PTR TO screen,dri=0:PTR TO drawinfo
DEF font:PTR TO textfont,dripens[NUMDRIPENS]:ARRAY OF INT
DEF bw=4,bh=4,fw=128,fh=128,fy,ww,wh,wx=0,wy=-1,th
DEF chunk=0,hx=15,hy=15,sx=0,sy=-1,eaten=0,playing=0,cx=-1,cy=-1,counter=3,speed=3
DEF fifox[1024]:ARRAY OF INT,fifoy[1024]:ARRAY OF INT,fifos=0,fifoe=0,fifol=1
DEF matrix[1024]:ARRAY OF INT,killtask=FALSE,gameover=0
DEF keybuf[256]:ARRAY OF CHAR,keybufs=1,keybufe=0,keybufl=0
DEF fillp[7]:ARRAY OF LONG,datatype[7]:ARRAY OF LONG,cp=0,paused=0
DEF wantobtainpens=0,pensobtained=0,visible=0
DEF bgs=0,efs=0,crs=0
DEF kp=0:PTR TO kprefs,rexxPort=0:PTR TO mp,rexxwait=0
DEF broker=0,brokerPort=0:PTR TO mp
DEF appicon=0,appmenu=0,myicon=0:PTR TO diskobject,appPort=0:PTR TO mp

ENUM CXID_POPKEY=1
ENUM APPID_ICON=1,APPID_MENU

PROC launchclients() HANDLE
    DEF fib=0:PTR TO fileinfoblock,lock=0,olddir,cc=0
    fib:=AllocDosObject(DOS_FIB,NIL)
    lock:=Lock('PROGDIR:Clients',ACCESS_READ)
    IF lock=0 THEN Raise(1)
    IF Examine(lock,fib)
        olddir:=CurrentDir(lock)
        WHILE ExNext(lock,fib)
            IF fib.direntrytype<0
                IF launchClient(fib.filename)=0 THEN INC cc
            ENDIF
        ENDWHILE
        CurrentDir(olddir)
    ENDIF
EXCEPT DO
    IF lock THEN UnLock(lock)
    IF fib THEN FreeDosObject(DOS_FIB,fib)
    IF exception>1 THEN ReThrow()
ENDPROC

PROC launchClient(name) IS SystemTagList(name,[SYS_ASYNCH,TRUE,SYS_INPUT,NIL,SYS_OUTPUT,NIL,NIL])

PROC readsounds()
    IF StrLen(kp.startgamesound) THEN bgs:=KsReadSoundObject(kp.startgamesound)
    IF StrLen(kp.eatfruitsound) THEN efs:=KsReadSoundObject(kp.eatfruitsound)
    IF StrLen(kp.crashsound) THEN crs:=KsReadSoundObject(kp.crashsound)
ENDPROC

PROC freesounds()
    KsDeleteSoundObject(bgs)
    KsDeleteSoundObject(efs)
    KsDeleteSoundObject(crs)
ENDPROC

PROC obtainpen(a)
    SELECT 2 OF kp.fill[a].type
        CASE FILLTYPE_RGB
            fillp[a]:=ObtainBestPenA(s.viewport.colormap,v32(kp.fill[a].red),v32(kp.fill[a].green),v32(kp.fill[a].blue),[OBP_PRECISION,PRECISION_EXACT,NIL])
        CASE FILLTYPE_DATATYPE
            datatype[a]:=createImageData(kp.fill[a].file,s)
    ENDSELECT
ENDPROC

PROC v32(x) IS Or(Shl(x,24),Or(Shl(x,16),Or(Shl(x,8),x)))

PROC obtainpens()
    DEF gfxver,a
    MOVE.L  gfxbase,A0
    MOVE.W  20(A0),gfxver
    IF gfxver>=39
        pensobtained:=1
        FOR a:=0 TO 6 DO obtainpen(a)
    ENDIF
ENDPROC

PROC freepens()
    DEF a
    FOR a:=0 TO 6
        SELECT 2 OF kp.fill[a].type
            CASE FILLTYPE_RGB
                IF fillp[a]<>-1 THEN ReleasePen(s.viewport::viewport.colormap,fillp[a])
            CASE FILLTYPE_DATATYPE
                IF datatype[a] THEN disposeImageData(datatype[a])
        ENDSELECT
    ENDFOR
ENDPROC
 
PROC dumpsettings() HANDLE
    DEF f=0
    f:=Open('ENVARC:KRSNAke/KRSNAke.snapshot',MODE_NEWFILE)
    IF f=0 THEN Raise("URK")
    VfPrintf(f,'%ld\n%ld\n%ld\n%ld\n%ld\n',[w.leftedge,w.topedge,bw,bh,speed])
EXCEPT DO
    IF f THEN Close(f)
ENDPROC

PROC readnumeral(f)
    DEF i,b[256]:ARRAY OF CHAR
    IF (Fgets(f,b,255)=0) THEN Raise("URK")
    i:=Val(b)
ENDPROC i

PROC readsettings() HANDLE
    DEF f=0
    f:=Open('ENVARC:KRSNAke/KRSNAke.snapshot',MODE_OLDFILE)
    IF f=0 THEN Raise("URK")
    wx:=readnumeral(f)
    wy:=readnumeral(f)
    bw:=readnumeral(f)
    fw:=bw*32
    bh:=readnumeral(f)
    fh:=bh*32
    speed:=readnumeral(f)
    Close(f);f:=0
    kp:=KsReadKRSNAkePrefs()
    IF kp=0 THEN Raise("Pref")
    wantobtainpens:=TRUE
EXCEPT DO
    IF f THEN Close(f)
ENDPROC

PROC bevelbox(x1,y1,x2,y2,dir=TRUE,bf=0)
    DEF shine,shadow
    IF dir
        shine:=dripens[SHINEPEN]
        shadow:=dripens[SHADOWPEN]
    ELSE
        shine:=dripens[SHADOWPEN]
        shadow:=dripens[SHINEPEN]
    ENDIF
    SetAPen(stdrast,shine)
    RectFill(stdrast,x1,y1,x1,y2)
    RectFill(stdrast,x1+1,y1,x2-1,y1)
    SetAPen(stdrast,shadow)
    RectFill(stdrast,x1+1,y2,x2,y2)
    RectFill(stdrast,x2,y1,x2,y2-1)
    IF bf
        SetAPen(stdrast,bf)
        RectFill(stdrast,x1+1,y1+1,x2-1,y2-1)
    ENDIF
ENDPROC

PROC renderlink(x,y,p)
    DEF sx,sy
    sx:=(x*bw)+4
    sy:=(y*bh)+fy
    IF p>FILL_BACK
        bevelbox(sx,sy,sx+bw-1,sy+bh-1,TRUE)
        renderfill(sx+1,sy+1,sx+bw-2,sy+bh-2,p)
    ELSE
        renderfill(sx,sy,sx+bw-1,sy+bh-1,FILL_BACK)
    ENDIF
ENDPROC

PROC renderfill(x1,y1,x2,y2,p)
    DEF r:rectangle,d:PTR TO imagedata
    SELECT 3 OF kp.fill[p].type
        CASE FILLTYPE_RGB
            SetAPen(stdrast,fillp[p])
            RectFill(stdrast,x1,y1,x2,y2)
        CASE FILLTYPE_DATATYPE
            d:=datatype[p]
            r.minx:=x1
            r.maxx:=x2
            r.miny:=y1
            r.maxy:=y2
            copyTiledBitMap(d,stdrast,r)
    ENDSELECT
ENDPROC

PROC rendersnake()
    DEF i,p
    renderfill(4,fy,fw+3,fh+fy-1,FILL_BACK)
    i:=fifol
    p:=fifos
    REPEAT
        IF i>1
            renderlink(fifox[p],fifoy[p],FILL_LINK)
        ELSE
            renderlink(fifox[p],fifoy[p],FILL_HEAD)
        ENDIF
        p:=p+1
        IF p>=1024 THEN p:=0
        i:=i-1
    UNTIL i=0
    IF (cx>=0) AND (cy>=0) THEN renderlink(cx,cy,FILL_FRUIT+cp)
ENDPROC

PROC pushlink(x,y)
    fifoe:=fifoe+1
    fifol:=fifol+1
    IF fifoe>=1024 THEN fifoe:=0
    fifox[fifoe]:=x
    fifoy[fifoe]:=y
    matrix[(y*32)+x]:=1
ENDPROC

PROC poplink()
    DEF x,y
    x:=fifox[fifos]
    y:=fifoy[fifos]
    fifos:=fifos+1
    fifol:=fifol-1
    IF fifos>=1024 THEN fifos:=0
    matrix[(y*32)+x]:=0
ENDPROC x,y

PROC pushkey(key)
    IF (key<$80) AND (key<>keybuf[keybufe])
        keybufe:=keybufe+1
        keybufl:=keybufl+1
        IF keybufe>=256 THEN keybufe:=0
        keybuf[keybufe]:=key
    ENDIF
ENDPROC

PROC popkey()
    DEF key
    IF keybufl<=0 THEN RETURN 0
    key:=keybuf[keybufs]
    keybufs:=keybufs+1
    keybufl:=keybufl-1
    IF keybufs>=256 THEN keybufs:=0
ENDPROC key

PROC renderscore(redraw=TRUE)
    DEF sw,ss[64]:STRING
    IF redraw
        SetAPen(stdrast,dripens[BACKGROUNDPEN])
        RectFill(stdrast,1,3,ww-2,th+2)
    ENDIF
    IF playing THEN StringF(ss,'Score:\d  Next:\d',fifol,chunk)
    IF (playing=0) AND (gameover=0) THEN StringF(ss,'Link size: [\d,\d]',bw,bh)
    IF (playing=0) AND (gameover=1) THEN StringF(ss,'Game over! You scored \d',fifol)
    sw:=TextLength(stdrast,ss,EstrLen(ss))
    SetAPen(stdrast,dripens[TEXTPEN])
    Move(stdrast,(ww-sw)/2,3+font.baseline)
    Text(stdrast,ss,EstrLen(ss))
ENDPROC

PROC render()
    DEF rw,rh
    ww:=w.width-w.borderleft-w.borderright
    wh:=w.height-w.bordertop-w.borderbottom
    fw:=ww-8
    fh:=wh-th-14
    fy:=th+10
    bw:=fw/32
    bh:=fh/32
    rw:=bw*32
    rh:=bh*32
    IF (fw-rw) OR (fh-rh) THEN JUMP done

    SetRast(stdrast,dripens[BACKGROUNDPEN])
    bevelbox(0,0,ww-1,th+5)
    bevelbox(0,fy-4,ww-1,wh-1)
    bevelbox(3,fy-1,ww-4,wh-4,FALSE)
    renderscore(FALSE)
    rendersnake()
done:
ENDPROC

PROC verifysize()
    DEF rw,rh,aw,ah
    aw:=w.width
    ah:=w.height
    fw:=aw-w.borderleft-w.borderright-8
    fh:=ah-w.bordertop-w.borderbottom-th-14
    bw:=fw/32
    bh:=fh/32
    rw:=bw*32
    rh:=bh*32
    IF (fw-rw) OR (fh-rh)
        aw:=aw-(fw-rw)
        ah:=ah-(fh-rh)
        ChangeWindowBox(w,w.leftedge,w.topedge,aw,ah)
    ENDIF
ENDPROC

PROC newchunk()
    REPEAT
        cx:=Rnd(32)
        cy:=Rnd(32)
    UNTIL matrix[(cy*32)+cx]=0
    chunk:=Rnd(9)+1
    cp:=Rnd(4)
    KsNotifyClients(krs,SNAKE_NEWCHUNK,Shl(chunk,24) OR Shl(cp,16) OR Shl(cy,8) OR cx)
    renderlink(cx,cy,FILL_FRUIT+cp)
ENDPROC

PROC movesnake()
    DEF alive=1,x,y,key
    key:=popkey()
    IF paused=1
        IF key
            KsNotifyClients(krs,SNAKE_RESTARTED,fifol)
            WaitTOF()
            paused:=0
        ELSE
            RETURN 1
        ENDIF
    ENDIF
    IF playing=0
        IF key=$40
            resetgame()
        ELSE
            RETURN 0
        ENDIF
    ENDIF
    IF (key>0) AND (key<11)
        speed:=key
    ELSE
        SELECT key
            CASE $4C
                IF (sy<>1) OR And(kp.flags,KPF_LETHAL180)
                    sx:=0
                    sy:=-1
                ENDIF
            CASE $4D
                IF (sy<>-1) OR And(kp.flags,KPF_LETHAL180)
                    sx:=0
                    sy:=1
                ENDIF
            CASE $4E
                IF (sx<>-1) OR And(kp.flags,KPF_LETHAL180)
                    sx:=1
                    sy:=0
                ENDIF
            CASE $4F
                IF (sx<>1) OR And(kp.flags,KPF_LETHAL180)
                    sx:=-1
                    sy:=0
                ENDIF
            CASE $45
                killtask:=TRUE
            CASE $19
                KsNotifyClients(krs,SNAKE_PAUSED,fifol)
                WaitTOF()
                paused:=1
        ENDSELECT
    ENDIF
    hx:=hx+sx
    hy:=hy+sy
    IF rexxwait>0 THEN DEC rexxwait
    IF (hx<0) OR (hx>31) OR (hy<0) OR (hy>31) OR (matrix[(hy*32)+hx]=1) OR (fifol>=1023)
        KsNotifyClients(krs,SNAKE_GAMEOVER,fifol)
        KsPlaySoundObject(crs)
        alive:=0
        playing:=0
        gameover:=1
        keybufs:=1
        keybufe:=0
        keybufl:=0
        rexxwait:=0
        renderscore()
    ELSE
        KsNotifyClients(krs,SNAKE_MOVES,Shl(hy,8) OR hx)
        renderlink(fifox[fifoe],fifoy[fifoe],FILL_LINK)
        pushlink(hx,hy)
        renderlink(hx,hy,FILL_HEAD)
        IF (hx=cx) AND (hy=cy)
            KsNotifyClients(krs,SNAKE_EATEN,chunk)
            KsPlaySoundObject(efs)
            eaten:=eaten+chunk
            newchunk()
        ENDIF
        IF eaten
            eaten:=eaten-1
            KsNotifyClients(krs,SNAKE_NEWSCORE,fifol)
            renderscore()
        ELSE
            x,y:=poplink()
            renderlink(x,y,FILL_BACK)
        ENDIF
    ENDIF
ENDPROC alive

PROC resetgame()
    DEF i
    KsNotifyClients(krs,SNAKE_NEWGAME,NIL)
    KsPlaySoundObject(bgs)
    FOR i:=0 TO 1023 DO matrix[i]:=0
    playing:=1
    fifos:=0
    fifoe:=0
    fifol:=1
    fifox[0]:=15
    fifoy[0]:=15
    sx:=0
    sy:=-1
    chunk:=0
    eaten:=0
    hx:=15
    hy:=15
    cx:=-1
    cy:=-1
    gameover:=0
    paused:=0
    newchunk()
    renderscore()
    rendersnake()
ENDPROC

PROC waitimessage(win:PTR TO window)
    DEF msg:PTR TO intuimessage,icl=0,ico=0
    DEF jpv

    IF visible
        WaitTOF()

        IF lowlevelbase
            jpv:=ReadJoyPort(1) AND JP_DIRECTION_MASK
            SELECT jpv
                CASE JPF_JOY_UP
                    pushkey($4C)
                CASE JPF_JOY_DOWN
                    pushkey($4D)
                CASE JPF_JOY_RIGHT
                    pushkey($4E)
                CASE JPF_JOY_LEFT
                    pushkey($4F)
            ENDSELECT
        ENDIF

        IF playing=0 THEN paused:=0
        IF counter
            counter:=counter-1
        ELSE
            counter:=speed
            playing:=movesnake()
        ENDIF

        WHILE (msg:=GetMsg(win.userport))
            icl:=msg.class
            ico:=msg.code
            ReplyMsg(msg)
            SELECT icl
                CASE IDCMP_CLOSEWINDOW
                    killtask:=TRUE
                CASE IDCMP_REFRESHWINDOW
                    render()
                CASE IDCMP_NEWSIZE
                    verifysize()
                    render()
                CASE IDCMP_INACTIVEWINDOW
                    IF playing
                        KsNotifyClients(krs,SNAKE_PAUSED,fifol)
                        paused:=1
                    ENDIF
                CASE IDCMP_RAWKEY
                    IF ico=$45 THEN killtask:=TRUE
                    pushkey(ico)
            ENDSELECT
        ENDWHILE
        checkRexxCommands()
        checkCxPort()
    ELSE
        Wait(Shl(1,appPort.sigbit) OR Shl(1,brokerPort.sigbit) OR Shl(1,rexxPort.sigbit))
        checkRexxCommands()
        checkCxPort()
        checkAppPort()
    ENDIF
ENDPROC

PROC uffGetMsg(port,uff:PTR TO LONG)
    DEF m,s
    m,s:=rx_GetMsg(port)
    ^uff:=s
ENDPROC m

PROC checkCxPort()
    DEF msg,id,type
    WHILE (msg:=GetMsg(brokerPort))
        id:=CxMsgID(msg)
        type:=CxMsgType(msg)
        SELECT type
            CASE CXM_IEVENT
                SELECT id
                    CASE CXID_POPKEY
                        IF visible THEN vanish() ELSE appear()
                ENDSELECT
            CASE CXM_COMMAND
                SELECT id
                    CASE CXCMD_KILL
                        killtask:=1
                    CASE CXCMD_DISAPPEAR
                        IF visible THEN vanish()
                    CASE CXCMD_APPEAR
                        IF visible=0 THEN appear()
                    CASE CXCMD_UNIQUE
                        IF visible=0 THEN appear()
                ENDSELECT
        ENDSELECT
        ReplyMsg(msg)
    ENDWHILE
ENDPROC

PROC checkAppPort()
    DEF msg:PTR TO appmessage
    WHILE (msg:=GetMsg(appPort))
        IF msg.numargs>0
            DisplayBeep(NIL)
        ELSE
            appear()
        ENDIF
        ReplyMsg(msg)
    ENDWHILE
ENDPROC

PROC checkRexxCommands()
    DEF msg,s:PTR TO CHAR,rc,a,b,c,st[32]:STRING,sr:PTR TO CHAR
    IF rexxwait=0
        WHILE (msg:=uffGetMsg(rexxPort,{s}))
            rc:=0
            sr:=0
            IF Stricmp(s,'UP')=0
                IF playing THEN pushkey($4C)
            ELSEIF Stricmp(s,'DOWN')=0
                IF playing THEN pushkey($4D)
            ELSEIF Stricmp(s,'RIGHT')=0
                IF playing THEN pushkey($4E)
            ELSEIF Stricmp(s,'LEFT')=0
                IF playing THEN pushkey($4F)
            ELSEIF Stricmp(s,'QUIT')=0
                killtask:=1
            ELSEIF Stricmp(s,'NEWGAME')=0
                IF playing=0 THEN pushkey($40) ELSE rc:=5
            ELSEIF Stricmp(s,'VERSION')=0
                sr:=KRSNAKEVER
            ELSEIF Stricmp(s,'HIDE')=0
                IF visible THEN vanish()
            ELSEIF Stricmp(s,'SHOW')=0
                IF visible=0 THEN appear()
            ELSEIF Strnicmp(s,'WAIT ',5)=0
                IF playing
                    a,c:=Val(s+5)
                    IF c>0
                        rexxwait:=a
                    ELSE
                        rc:=20
                    ENDIF
                ENDIF
            ELSEIF Strnicmp(s,'SET SPEED ',10)=0
                a,c:=Val(s+10)
                IF c>0
                    speed:=a
                ELSE
                    rc:=20
                ENDIF
            ELSEIF Stricmp(s,'GET LENGTH')=0
                StringF(st,'\d',fifol)
                sr:=st
            ELSEIF Stricmp(s,'GET PLAYING')=0
                StringF(st,'\d',playing)
                sr:=st
            ELSEIF Stricmp(s,'PAUSE')=0
                IF playing
                    KsNotifyClients(krs,SNAKE_PAUSED,fifol)
                    paused:=1
                ENDIF
            ELSEIF Stricmp(s,'GET HEAD X')=0
                StringF(st,'\d',hx)
                sr:=st
            ELSEIF Stricmp(s,'GET HEAD Y')=0
                StringF(st,'\d',hy)
                sr:=st
            ELSEIF Stricmp(s,'GET FRUIT X')=0
                IF playing
                    StringF(st,'\d',cx)
                    sr:=st
                ELSE
                    rc:=20
                ENDIF
            ELSEIF Stricmp(s,'GET FRUIT Y')=0
                IF playing
                    StringF(st,'\d',cy)
                    sr:=st
                ELSE
                    rc:=20
                ENDIF
            ELSEIF Strnicmp(s,'CHECK ',6)=0
                a,c:=Val(s+6)
                IF c>0
                    b,c:=Val(s+6+c)
                    IF c>0
                        StringF(st,'\d',matrix[(b*32)+a])
                        sr:=st
                    ENDIF
                ENDIF
                IF c=0 THEN rc:=20
            ENDIF
            rx_ReplyMsg(msg,rc,sr)
        ENDWHILE
    ENDIF
ENDPROC

PROC openKRSNAkeLib()
    DEF base=0:PTR TO lib
    base:=OpenLibrary('krsnake.library',1)
    IF base=0 THEN OpenLibrary('Libs/krsnake.library',1)
    IF base=0 THEN OpenLibrary('PROGDIR:Libs/krsnake.library',1)
    IF base
        IF base.revision<6
            CloseLibrary(base)
            Throw("LIB",'KRSNAke.library revision too old')
        ENDIF
    ENDIF
ENDPROC base

PROC createBroker()
    brokerPort:=CreateMsgPort()
    broker:=CxBroker([NB_VERSION,0,
                      'KRSNAke',KRSNAKEVER,
                      'The snake game',
                      NBU_UNIQUE,COF_SHOW_HIDE,0,0,
                      brokerPort,0]:newbroker,NIL)
    AttachCxObj(broker,hotKey(kp.popkey,brokerPort,CXID_POPKEY))
    ActivateCxObj(broker,TRUE)
ENDPROC broker

PROC appear()
    IF visible=0
        IF appicon THEN RemoveAppIcon(appicon)
        IF appmenu THEN RemoveAppMenuItem(appmenu)
        appicon:=0;appmenu:=0
        IF StrLen(kp.pubscreen)
            s:=LockPubScreen(kp.pubscreen)
        ELSE
            s:=LockPubScreen(NIL)
        ENDIF
        font:=OpenFont(s.font)
        dri:=GetScreenDrawInfo(s)
        dripens:=dri.pens
        th:=font.ysize
        IF wy=-1 THEN wy:=s.barheight+1
        ww:=fw+8
        wh:=fh+th+14
        IF wantobtainpens THEN obtainpens()
        w:=OpenWindowTagList(NIL,[WA_INNERWIDTH,ww,WA_INNERHEIGHT,wh,
                                  WA_LEFT,wx,WA_TOP,wy,
                                  WA_TITLE,'KRSNAke v1.8',
                                  WA_SIZEGADGET,TRUE,
                                  WA_DRAGBAR,TRUE,
                                  WA_DEPTHGADGET,TRUE,
                                  WA_CLOSEGADGET,TRUE,
                                  WA_ACTIVATE,TRUE,
                                  WA_SMARTREFRESH,TRUE,
                                  WA_SIZEBBOTTOM,TRUE,
                                  WA_GIMMEZEROZERO,TRUE,
                                  WA_NEWLOOKMENUS,TRUE,
                                  WA_SCREENTITLE,'KRSNAke v1.8 - IGNE NATURA RENOVATUR INTEGRA!',
                                  WA_AUTOADJUST,TRUE,
                                  WA_PUBSCREEN,s,
                                  WA_RMBTRAP,TRUE,
                                  WA_IDCMP,IDCMP_CLOSEWINDOW OR IDCMP_REFRESHWINDOW OR IDCMP_INACTIVEWINDOW OR IDCMP_NEWSIZE OR IDCMP_RAWKEY,
                                  NIL])
        WindowLimits(w,w.borderleft+w.borderright+136,w.bordertop+w.borderbottom+th+142,-1,-1)
        SetStdRast(w.rport)
        SetFont(stdrast,font)
        render()
        visible:=1
        IF krs THEN KsShowInterface(krs)
    ENDIF
ENDPROC

PROC vanish(forever=FALSE)
    IF visible
        IF w THEN CloseWindow(w)
        IF pensobtained THEN freepens()
        IF dri THEN FreeScreenDrawInfo(s,dri)
        IF font THEN CloseFont(font)
        IF s THEN UnlockPubScreen(NIL,s)
        IF playing=1 THEN paused:=1
        IF krs THEN KsHideInterface(krs)
        w:=0;pensobtained:=0;dri:=0;font:=0;s:=0;visible:=0
        IF forever=0
            IF And(kp.flags,KPF_APPICON) THEN appicon:=AddAppIconA(APPID_ICON,0,'KRSNAke',appPort,NIL,myicon,NIL)
            IF And(kp.flags,KPF_APPMENU) THEN appmenu:=AddAppMenuItemA(APPID_MENU,0,'KRSNAke',appPort,NIL)
        ENDIF
    ENDIF
ENDPROC

PROC main() HANDLE
    trapguru()
    IF (krsnakebase:=openKRSNAkeLib())=0 THEN Throw("LIB",'krsnake.library')
    IF (utilitybase:=OpenLibrary('utility.library',37))=0 THEN Throw("LIB",'utility.library')
    IF (cxbase:=OpenLibrary('commodities.library',37))=0 THEN Throw("LIB",'commodities.library')
    IF (iconbase:=OpenLibrary('icon.library',37))=0 THEN Throw("LIB",'icon.library')
    IF (workbenchbase:=OpenLibrary('workbench.library',37))=0 THEN Throw("LIB",'workbench.library')
    datatypesbase:=OpenLibrary('datatypes.library',39)
    IF (lowlevelbase:=OpenLibrary('lowlevel.library',40)) THEN SetJoyPortAttrsA(1,[SJA_TYPE,SJA_TYPE_JOYSTK,NIL])
    myicon:=GetDiskObjectNew('PROGDIR:KRSNAke')
    krs:=KsRegisterServer()
    launchclients()
    fifox[0]:=15
    fifoy[0]:=15
    readsettings()
    SetTaskPri(FindTask(NIL),kp.priority)
    readsounds()
    appPort:=CreateMsgPort()
    createBroker()
    rexxPort:=rx_OpenPort('KRSNAKE')
    appear()

    REPEAT
        waitimessage(w)
    UNTIL killtask

    dumpsettings()

EXCEPT DO
    vanish(TRUE)
    IF krs THEN KsRemoveServer(krs)
    IF rexxPort THEN rx_ClosePort(rexxPort)
    IF broker THEN DeleteCxObj(broker)
    IF brokerPort THEN deletePortSafely(brokerPort)
    IF appicon THEN RemoveAppIcon(appicon)
    IF appmenu THEN RemoveAppMenuItem(appmenu)
    IF appPort THEN deletePortSafely(appPort)
    IF myicon THEN FreeDiskObject(myicon)
    IF kp THEN KsWriteKRSNAkePrefs(kp)
    freesounds()
    IF krsnakebase THEN CloseLibrary(krsnakebase)
    IF utilitybase THEN CloseLibrary(utilitybase)
    IF iconbase THEN CloseLibrary(iconbase)
    IF workbenchbase THEN CloseLibrary(workbenchbase)
    IF cxbase THEN CloseLibrary(cxbase)
    IF lowlevelbase THEN CloseLibrary(lowlevelbase)
    IF datatypesbase THEN CloseLibrary(datatypesbase)

    IF exception>0 THEN report_exception()
ENDPROC

PROC report_exception()
  DEF e[5]:ARRAY,s[256]:STRING,t[256]:STRING,p:PTR TO process
  IF exception
    StrCopy(s,'Program caused exception: ')
    IF exception<10000
      StringF(t,'\d\n',exception)
      StrAdd(s,t)
    ELSE
      SELECT exception
        CASE  "MEM"; StrCopy(t,'no memory')
        CASE "OPEN"; StringF(t,'could not open file \s',IF exceptioninfo THEN exceptioninfo ELSE '')
        CASE "LOCK"; StringF(t,'could not lock \s',IF exceptioninfo THEN exceptioninfo ELSE '')
        CASE  "WIN"; StringF(t,'could not open window \s',IF exceptioninfo THEN exceptioninfo ELSE '')
        CASE  "LIB"; StringF(t,'could not open library \s',IF exceptioninfo THEN exceptioninfo ELSE '')
        CASE   "^C"; StrCopy(t,'***BREAK')
        CASE "DOUB"; StrCopy(t,'ARexx port already exists!')
        CASE  "SIG"; StrCopy(t,'could not allocate signal')
        DEFAULT
          e[4]:=0
          ^e:=exception
          WHILE e[]=0 DO e++
          StringF(t,IF exceptioninfo<1000 THEN '"\s" [\d]' ELSE '"\s" [\s]',e,exceptioninfo)
      ENDSELECT
      StrAdd(s,t)
    ENDIF
    p:=FindTask(NIL)
    IF p.cli=0 THEN EasyRequestArgs(NIL,[SIZEOF easystruct,0,'Exception',s,' OK '],NIL,NIL) ELSE WriteF('\s\n',s)
  ENDIF
ENDPROC

krsnakever: CHAR '$VER: KRSNAke 1.008 (22 Sep 1995) beta',0


