->
-> NOVUS ORDO SECLORUM!
->
->         -><- KRSNAkePrefs -><-
->
-> Prefs tool for KRSNAke
->
-> Copyright  1995 Psilocybe Software
->
-> This program is free software; you can redistribute it and/or modify
-> it under the terms of the GNU General Public License as published by
-> the Free Software Foundation; either version 2 of the License, or
-> (at your option) any later version.
->
-> This program is distributed in the hope that it will be useful,
-> but WITHOUT ANY WARRANTY; without even the implied warranty of
-> MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-> GNU General Public License for more details.
->
-> You should have received a copy of the GNU General Public License
-> along with this program; if not, write to the Free Software
-> Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
->
-> $HISTORY:
->
-> 22 Sep 1995 : 002.002 :  Added some new items
-> 05 Sep 1995 : 002.001 :  Initial revision
->
-> Machaben!
->

OPT PREPROCESS

MODULE 'gtlayout','gadtools','libraries/gtlayout','libraries/gadtools'
MODULE 'utility/tagitem','intuition/intuition','tools/exceptions','tools/trapguru'
MODULE 'libraries/gtlayoutmacros','exec/ports','dos/dos'
MODULE 'asl','libraries/asl','intuition/screens','graphics/view','tools/installhook'
MODULE 'utility/hooks','graphics/rastport','graphics/rpattr','datatypes'
MODULE 'datatypes/datatypes','datatypes/datatypesclass','datatypes/pictureclass'
MODULE 'amigalib/boopsi','graphics/gfx','graphics/clip','libraries/krsnake'
MODULE 'krsnake','tools/constructors','exec/lists','exec/nodes'

MODULE '*tiledbitmap'

RAISE "MEM"  IF OpenLibrary()=0,
      "GTLO" IF Lt_BuildA()=0,
      "GTLO" IF Lt_CreateHandleTagList()=0,
      "FILE" IF Open()=0,
      "PUBS" IF LockPubScreen()=0,
      "MEM"  IF KsReadKRSNAkePrefs()=0

#define VERSION '$VER: KRSNAkePrefs 2.002 (22 Sep 1995) Stab'

CONST COL_BACKGROUND=0,
      COL_SNAKEBODY=3,
      COL_SNAKEHEAD=6,
      COL_FRUIT1=9,
      COL_FRUIT2=12,
      COL_FRUIT3=15,
      COL_FRUIT4=18,
      COL_SIZE=21

DEF mhandle:PTR TO layouthandle,phandle:PTR TO layouthandle
DEF mwin:PTR TO window,pwin:PTR TO window
DEF mmask,mmenu,cpen=-1,image:PTR TO LONG
DEF cframehook:hook
DEF kp=0:PTR TO kprefs,sample=0

ENUM GAD_RED=1,GAD_GREEN,GAD_BLUE,GAD_PUBSCREEN,GAD_PRI,GAD_LETHAL,
     GAD_STARTGAME,GAD_EATFRUIT,GAD_CRASH,GAD_COLSEL,GAD_RGB,GAD_IMAGE,
     GAD_COLTYPE,GAD_COLTYPEGROUP,GAD_TEST1,GAD_TEST2,GAD_TEST3,GAD_POPKEY,
     GAD_APPICON,GAD_APPMENU,MAX_GADS

PROC createMainWindow()
    DEF gthandle:PTR TO layouthandle
    CreateHandle(NIL),LH_AUTOACTIVATE,FALSE,LH_MENUGLYPHS,TRUE,LH_CLONINGPERMITTED,FALSE,End
        VGROUP,End
            VGROUP,LA_LABELTEXT,'Options',End
                StringGadget,GTST_MAXCHARS,64,LA_LABELTEXT,'Public Screen',
                             GTST_STRING,kp.pubscreen,
                             LA_CHARS,40,LAST_PICKER,TRUE,LA_ID,GAD_PUBSCREEN,End
                StringGadget,GTST_MAXCHARS,64,LA_LABELTEXT,'Popkey',
                             GTST_STRING,kp.popkey,LA_CHARS,40,LA_ID,GAD_POPKEY,End
                LevelGadget,GTSL_MIN,-3,GTSL_MAX,3,LA_LABELTEXT,'Task Priority',
                            GTSL_LEVEL,kp.priority,
                            LA_CHARS,40,LA_ID,GAD_PRI,End
                CheckboxGadget,LA_LABELTEXT,'180 turns lethal',LA_ID,GAD_LETHAL,
                               GTCB_CHECKED,And(kp.flags,KPF_LETHAL180),End
                CheckboxGadget,LA_LABELTEXT,'AppIcon when hidden',LA_ID,GAD_APPICON,
                               GTCB_CHECKED,And(kp.flags,KPF_APPICON),End
                CheckboxGadget,LA_LABELTEXT,'AppMenu when hidden',LA_ID,GAD_APPMENU,
                               GTCB_CHECKED,And(kp.flags,KPF_APPMENU),End
            ENDGROUP
            HGROUP,LA_LABELTEXT,'Sounds',End
                VGROUP,End
                    StringGadget,GTST_MAXCHARS,256,LA_LABELTEXT,'Start Game',
                                 GTST_STRING,kp.startgamesound,
                                 LA_CHARS,35,LAST_PICKER,TRUE,LA_ID,GAD_STARTGAME,End
                    StringGadget,GTST_MAXCHARS,256,LA_LABELTEXT,'Eat Fruit',
                                 GTST_STRING,kp.eatfruitsound,
                                 LA_CHARS,35,LAST_PICKER,TRUE,LA_ID,GAD_EATFRUIT,End
                    StringGadget,GTST_MAXCHARS,256,LA_LABELTEXT,'Crash',
                                 GTST_STRING,kp.crashsound,
                                 LA_CHARS,35,LAST_PICKER,TRUE,LA_ID,GAD_CRASH,End
                ENDGROUP
                VGROUP,End
                    ButtonGadget,LA_LABELTEXT,'Test',LA_ID,GAD_TEST1,End
                    ButtonGadget,LA_LABELTEXT,'Test',LA_ID,GAD_TEST2,End
                    ButtonGadget,LA_LABELTEXT,'Test',LA_ID,GAD_TEST3,End
                ENDGROUP
            ENDGROUP
            HGROUP,LA_LABELTEXT,'Colours',End
                VGROUP,End
                    ListviewGadget,LALV_LABELS,['Background','Snake body','Snake head',
                                                'Fruit 1','Fruit 2','Fruit 3','Fruit 4',NIL],
                                   LALV_CURSORKEY,TRUE,LA_CHARS,10,LALV_LINES,7,
                                   LALV_LINK,NIL_LINK,LA_ID,GAD_COLSEL,
                                   GTLV_SELECTED,0,End
                ENDGROUP
                HGROUP,TRUE,End
                    VGROUP,End
                        FrameGadget,LAFR_DRAWBOX,FALSE,LAFR_REFRESHHOOK,cframehook,End
                        FrameGadget,LAFR_INNERWIDTH,64,LAFR_INNERHEIGHT,64,LA_ID,GAD_RGB,
                                    LAFR_DRAWBOX,TRUE,LAFR_REFRESHHOOK,cframehook,End
                        FrameGadget,LAFR_DRAWBOX,FALSE,LAFR_REFRESHHOOK,cframehook,End
                    ENDGROUP
                    VGROUP,End
                        VGROUP,End
                            CycleGadget,GTCY_LABELS,['RGB Colour','Datatypes Image',NIL],
                                        LACY_TABKEY,TRUE,LA_ID,GAD_COLTYPE,End
                        ENDGROUP
                        VGROUP,LAGR_ACTIVEPAGE,0,LAGR_FRAME,TRUE,LA_ID,GAD_COLTYPEGROUP,End
                            VGROUP,End
                                LevelGadget,LA_LABELTEXT,'Red',GTSL_MIN,0,GTSL_MAX,255,
                                            LA_CHARS,30,LA_ID,GAD_RED,GTSL_LEVEL,kp.fill[0].red,End
                                LevelGadget,LA_LABELTEXT,'Green',GTSL_MIN,0,GTSL_MAX,255,
                                            LA_CHARS,30,LA_ID,GAD_GREEN,GTSL_LEVEL,kp.fill[0].green,End
                                LevelGadget,LA_LABELTEXT,'Blue',GTSL_MIN,0,GTSL_MAX,255,
                                            LA_CHARS,30,LA_ID,GAD_BLUE,GTSL_LEVEL,kp.fill[0].blue,End
                            ENDGROUP
                            VGROUP,End
                                StringGadget,GTST_MAXCHARS,256,LA_LABELTEXT,'Image',
                                             GTST_STRING,kp.fill[0].file,
                                             LA_CHARS,30,LAST_PICKER,TRUE,LA_ID,GAD_IMAGE,End
                            ENDGROUP
                        ENDGROUP
                    ENDGROUP
                ENDGROUP
            ENDGROUP
        ENDGROUP
    mmenu:=createMenu(gthandle)
    mwin:=Build,LAWN_TITLE,'KRSNAkePrefs 1.8',LAWN_IDCMP,IDCMP_GADGETDOWN OR IDCMP_CLOSEWINDOW OR IDCMP_MOUSEMOVE,
                                LAWN_SMARTZOOM,TRUE,LAWN_MENU,mmenu,
                                WA_CLOSEGADGET,TRUE,WA_DRAGBAR,TRUE,
                                WA_DEPTHGADGET,TRUE,End
    mhandle:=gthandle
ENDPROC Shl(1,mwin.userport.sigbit)

PROC createPSWindow(list)
    DEF gthandle:PTR TO layouthandle
    CreateHandle(NIL),LH_AUTOACTIVATE,FALSE,End
        VGROUP,LA_LABELTEXT,'Public Screens',End
            ListviewGadget,LALV_CURSORKEY,TRUE,LA_CHARS,30,LALV_LINES,10,
                           LALV_RESIZEY,TRUE,LALV_LINK,NIL_LINK,LA_ID,1,
                           GTLV_LABELS,list,LALV_RESIZEX,TRUE,GTLV_SELECTED,0,End
        ENDGROUP
    pwin:=Build,LAWN_TITLE,'Select a public screen',LAWN_IDCMP,IDCMP_CLOSEWINDOW OR IDCMP_IDCMPUPDATE,
                                LAWN_SMARTZOOM,TRUE,WA_RMBTRAP,TRUE,
                                WA_CLOSEGADGET,TRUE,WA_DRAGBAR,TRUE,
                                LAWN_PARENT,mwin,LAWN_BLOCKPARENT,TRUE,
                                WA_DEPTHGADGET,TRUE,End
    phandle:=gthandle
ENDPROC Shl(1,pwin.userport.sigbit)

PROC createMenu(handle:PTR TO layouthandle)
    DEF menu:PTR TO menu
    menu:=Lt_LayoutMenusA(handle,[NM_TITLE,0,'Project',0,0,0,0,
                                  NM_ITEM,0,   'About...','?',0,0,0,
                                  NM_ITEM,0,   NM_BARLABEL,0,0,0,0,
                                  NM_ITEM,0,   'Quit','ESC',NM_COMMANDSTRING,0,0,
                                  NM_END]:newmenu,NIL)
ENDPROC menu

PROC deleteMainWindow()
    IF mhandle
        Lt_DeleteHandle(mhandle)
        mhandle:=0
    ENDIF
ENDPROC

PROC deletePSWindow()
    IF phandle
        Lt_DeleteHandle(phandle)
        phandle:=0
    ENDIF
ENDPROC

PROC copyList(list:PTR TO lh)
    DEF nl:PTR TO lh,in:PTR TO ln
    nl:=newlist()
    in:=list.head
    WHILE in.succ
        AddTail(nl,copyNode(in))
        in:=in.succ
    ENDWHILE
ENDPROC nl

PROC copyNode(n:PTR TO ln)
    DEF nn:PTR TO ln
    nn:=NewR(SIZEOF ln+StrLen(n.name)+1)
    nn.name:=nn+SIZEOF ln
    copystring(nn.name,n.name)
ENDPROC nn

PROC deleteList(l:PTR TO lh)
    DEF n:PTR TO ln
    WHILE n:=RemHead(l) DO Dispose(n)
    END l
ENDPROC

PROC getNode(l:PTR TO lh,c)
    DEF n:PTR TO ln
    n:=l.head
    WHILE n.succ
        IF c=0 THEN RETURN n
        DEC c
        n:=n.succ
    ENDWHILE
ENDPROC 0

PROC selectPubScreen()
    DEF mask,l,pl,done=0,msg:PTR TO intuimessage,n:PTR TO ln,
        msgclass,msgcode,msgqualifier,msggadget:PTR TO gadget

    pl:=LockPubScreenList()
    l:=copyList(pl)
    UnlockPubScreenList()
    mask:=createPSWindow(l)
    ActivateWindow(pwin)

    WHILE done=0
        Wait(mask)
        WHILE (msg:=Lt_GetIMsg(phandle))
            msgclass:=msg.class
            msgcode:=msg.code
            msgqualifier:=msg.qualifier
            msggadget:=msg.iaddress
            Lt_ReplyIMsg(msg)
            SELECT msgclass
                CASE IDCMP_CLOSEWINDOW
                    done:=1
                CASE IDCMP_IDCMPUPDATE
                    IF msggadget.gadgetid=1
                        done:=2
                    ENDIF
            ENDSELECT
        ENDWHILE
    ENDWHILE

    deletePSWindow()
    IF done=2
        n:=getNode(l,msgcode)
        Lt_SetAttributesA(mhandle,GAD_PUBSCREEN,[GTST_STRING,n.name,TAG_DONE])
    ENDIF
    deleteList(l)
ENDPROC

PROC copystring(s2,s1)
    MOVE.L  s1,A0
    MOVE.L  s2,A1
copyloop:
    MOVE.B  (A0)+,D0
    CMP.B   #32,D0
    BLT     terminate
    MOVE.B  D0,(A1)+
    BRA     copyloop
terminate:
    CLR.B   (A1)+
ENDPROC

OBJECT refreshmessage -> refreshmsg in gtlayout.m is wrong
    id:LONG
    left:INT
    top:INT
    width:INT
    height:INT
ENDOBJECT

PROC renderCFrame(obj:PTR TO layouthandle,msg:PTR TO refreshmessage)
    DEF rp:PTR TO rastport,id,cc,dr=0,i:PTR TO imagedata,bounds:rectangle

    rp:=obj.window.rport
    id:=msg.id
    bounds.minx:=msg.left
    bounds.miny:=msg.top
    bounds.maxx:=msg.left+msg.width-1
    bounds.maxy:=msg.top+msg.height-1

    SELECT id
        CASE GAD_RGB
            cc:=Lt_GetAttributesA(mhandle,GAD_COLSEL,NIL)
            IF kp.fill[cc].type=FILLTYPE_RGB
                IF cpen=-1 THEN cpen:=ObtainPen(obj.screen.viewport.colormap,-1,v32(kp.fill[cc].red),v32(kp.fill[cc].green),v32(kp.fill[cc].blue),PEN_EXCLUSIVE)
                IF cpen>=0
                    SetAPen(rp,cpen)
                    RectFill(rp,msg.left,msg.top,msg.left+msg.width-1,msg.top+msg.height-1)
                    dr:=1
                ENDIF
            ELSEIF kp.fill[cc].type=FILLTYPE_DATATYPE
                IF image[cc]=0
                    image[cc]:=createImageData(kp.fill[cc].file,obj.screen)
                ENDIF
                IF image[cc]
                    i:=image[cc]
                    copyTiledBitMap(i,rp,bounds,1)
                    dr:=1
                ENDIF
            ENDIF
            IF dr=0
                SetAPen(rp,obj.drawinfo.pens[BACKGROUNDPEN])
                RectFill(rp,msg.left,msg.top,msg.left+msg.width-1,msg.top+msg.height-1)
                SetAPen(rp,obj.drawinfo.pens[BLOCKPEN])
                Move(rp,msg.left,msg.top)
                Draw(rp,msg.left+msg.width-1,msg.top+msg.height-1)
                Move(rp,msg.left,msg.top+msg.height-1)
                Draw(rp,msg.left+msg.width-1,msg.top)
            ENDIF
    ENDSELECT
ENDPROC 1

PROC pickFile(id)
    DEF req:PTR TO filerequester,p[256]:STRING,f[256]:STRING,a
    StrCopy(p,Lt_GetAttributesA(mhandle,id,NIL))
    StrCopy(f,FilePart(Lt_GetAttributesA(mhandle,id,NIL)))
    PutChar(PathPart(p),0)
    SetStr(p,StrLen(p))
    req:=AllocAslRequest(ASL_FILEREQUEST,[ASLFR_WINDOW,mhandle.window,
                                          ASLFR_SLEEPWINDOW,TRUE,
                                          ASLFR_TITLETEXT,'Select a file',
                                          ASLFR_INITIALFILE,f,
                                          ASLFR_INITIALDRAWER,p,
                                          ASLFR_REJECTICONS,TRUE,TAG_DONE])
    IF AslRequest(req,NIL)
        StrCopy(p,req.drawer)
        AddPart(p,req.file,255)
        SetStr(p,StrLen(p))
        Lt_SetAttributesA(mhandle,id,[GTST_STRING,p,TAG_DONE])
        FreeAslRequest(req)
        IF id=GAD_IMAGE
            a:=Lt_GetAttributesA(mhandle,GAD_COLSEL,NIL)
            copystring(kp.fill[a].file,p)
            IF image[a]
                disposeImageData(image[a])
                image[a]:=0
            ENDIF
            Lt_RebuildTagList(mhandle,FALSE,NIL)
        ENDIF
    ENDIF
ENDPROC

PROC v32(x) IS Or(Shl(x,24),Or(Shl(x,16),Or(Shl(x,8),x)))

PROC setrgbvalue()
    DEF l
    l:=Lt_GetAttributesA(mhandle,GAD_COLSEL,NIL)
    kp.fill[l].red:=Lt_GetAttributesA(mhandle,GAD_RED,NIL)
    kp.fill[l].green:=Lt_GetAttributesA(mhandle,GAD_GREEN,NIL)
    kp.fill[l].blue:=Lt_GetAttributesA(mhandle,GAD_BLUE,NIL)
ENDPROC

PROC main() HANDLE
    DEF msg:PTR TO intuimessage,msgqualifier,msgclass,msgcode,
        msggadget:PTR TO gadget,done=FALSE,sig,cdown=FALSE,a,b

    trapguru()

    image:=List(COL_SIZE/3)

    aslbase:=OpenLibrary('asl.library',37)
    gadtoolsbase:=OpenLibrary('gadtools.library',37)
    gtlayoutbase:=OpenLibrary('gtlayout.library',17)
    datatypesbase:=OpenLibrary('datatypes.library',39)
    krsnakebase:=OpenLibrary('krsnake.library',1)

    kp:=KsReadKRSNAkePrefs()

    installhook(cframehook,{renderCFrame})

    mmask:=createMainWindow()

    ActivateWindow(mwin)

    Lt_SetAttributesA(mhandle,GAD_RED,[GTSL_LEVEL,kp.fill[0].red,TAG_DONE])
    Lt_SetAttributesA(mhandle,GAD_GREEN,[GTSL_LEVEL,kp.fill[0].green,TAG_DONE])
    Lt_SetAttributesA(mhandle,GAD_BLUE,[GTSL_LEVEL,kp.fill[0].blue,TAG_DONE])
    Lt_SetAttributesA(mhandle,GAD_IMAGE,[GTST_STRING,kp.fill[0].file,TAG_DONE])
    Lt_SetAttributesA(mhandle,GAD_COLTYPE,[GTCY_ACTIVE,kp.fill[0].type,TAG_DONE])
    Lt_SetAttributesA(mhandle,GAD_COLTYPEGROUP,[LAGR_ACTIVEPAGE,kp.fill[0].type,TAG_DONE])
    IF cpen>=0 THEN SetRGB32(mhandle.screen.viewport,cpen,v32(Lt_GetAttributesA(mhandle,GAD_RED,NIL)),v32(Lt_GetAttributesA(mhandle,GAD_GREEN,NIL)),v32(Lt_GetAttributesA(mhandle,GAD_BLUE,NIL)))
    Lt_RebuildTagList(mhandle,FALSE,NIL)

    WHILE done=FALSE
        sig:=Wait(mmask)
        WHILE (msg:=Lt_GetIMsg(mhandle))
            msgclass:=msg.class
            msgcode:=msg.code
            msgqualifier:=msg.qualifier
            msggadget:=msg.iaddress
            Lt_ReplyIMsg(msg)
            SELECT msgclass
                CASE IDCMP_CLOSEWINDOW
                    done:=TRUE
                CASE IDCMP_GADGETDOWN
                    IF (msggadget.gadgetid=GAD_RED) OR (msggadget.gadgetid=GAD_GREEN) OR (msggadget.gadgetid=GAD_BLUE)
                        cdown:=TRUE
                    ENDIF
                CASE IDCMP_MOUSEMOVE
                    IF cdown
                        IF cpen>=0 THEN SetRGB32(mhandle.screen.viewport,cpen,v32(Lt_GetAttributesA(mhandle,GAD_RED,NIL)),v32(Lt_GetAttributesA(mhandle,GAD_GREEN,NIL)),v32(Lt_GetAttributesA(mhandle,GAD_BLUE,NIL)))
                    ENDIF
                CASE IDCMP_IDCMPUPDATE
                    SELECT MAX_GADS OF msggadget.gadgetid
                        CASE GAD_PUBSCREEN
                            selectPubScreen()
                        CASE GAD_IMAGE,GAD_STARTGAME,GAD_EATFRUIT,GAD_CRASH
                            pickFile(msggadget.gadgetid)
                    ENDSELECT
                CASE IDCMP_GADGETUP
                    SELECT MAX_GADS OF msggadget.gadgetid
                        CASE GAD_TEST1
                            playSound(mhandle,GAD_STARTGAME)
                        CASE GAD_TEST2
                            playSound(mhandle,GAD_EATFRUIT)
                        CASE GAD_TEST3
                            playSound(mhandle,GAD_CRASH)
                        CASE GAD_COLTYPE
                            a:=Lt_GetAttributesA(mhandle,GAD_COLSEL,NIL)
                            kp.fill[a].type:=msgcode
                            Lt_SetAttributesA(mhandle,GAD_COLTYPEGROUP,[LAGR_ACTIVEPAGE,msgcode,TAG_DONE])
                        CASE GAD_COLSEL
                            Lt_SetAttributesA(mhandle,GAD_RED,[GTSL_LEVEL,kp.fill[msgcode].red,TAG_DONE])
                            Lt_SetAttributesA(mhandle,GAD_GREEN,[GTSL_LEVEL,kp.fill[msgcode].green,TAG_DONE])
                            Lt_SetAttributesA(mhandle,GAD_BLUE,[GTSL_LEVEL,kp.fill[msgcode].blue,TAG_DONE])
                            Lt_SetAttributesA(mhandle,GAD_IMAGE,[GTST_STRING,kp.fill[msgcode].file,TAG_DONE])
                            Lt_SetAttributesA(mhandle,GAD_COLTYPE,[GTCY_ACTIVE,kp.fill[msgcode].type,TAG_DONE])
                            Lt_SetAttributesA(mhandle,GAD_COLTYPEGROUP,[LAGR_ACTIVEPAGE,kp.fill[msgcode].type,TAG_DONE])
                            IF cpen>=0 THEN SetRGB32(mhandle.screen.viewport,cpen,v32(Lt_GetAttributesA(mhandle,GAD_RED,NIL)),v32(Lt_GetAttributesA(mhandle,GAD_GREEN,NIL)),v32(Lt_GetAttributesA(mhandle,GAD_BLUE,NIL)))
                            Lt_RebuildTagList(mhandle,FALSE,NIL)
                        CASE GAD_RED TO GAD_BLUE
                            cdown:=FALSE
                            IF cpen>=0 THEN SetRGB32(mhandle.screen.viewport,cpen,v32(Lt_GetAttributesA(mhandle,GAD_RED,NIL)),v32(Lt_GetAttributesA(mhandle,GAD_GREEN,NIL)),v32(Lt_GetAttributesA(mhandle,GAD_BLUE,NIL)))
                            setrgbvalue()
                        CASE GAD_IMAGE
                            a:=Lt_GetAttributesA(mhandle,GAD_COLSEL,NIL)
                            b:=Lt_GetAttributesA(mhandle,GAD_IMAGE,NIL)
                            copystring(kp.fill[a].file,b)
                            IF image[a]
                                disposeImageData(image[a])
                                image[a]:=0
                            ENDIF
                            Lt_RebuildTagList(mhandle,FALSE,NIL)
                    ENDSELECT
                CASE IDCMP_MENUPICK
                    done:=handleMenuPick(msgcode)
            ENDSELECT
        ENDWHILE
    ENDWHILE

    copystring(kp.pubscreen,Lt_GetAttributesA(mhandle,GAD_PUBSCREEN,NIL))
    copystring(kp.popkey,Lt_GetAttributesA(mhandle,GAD_POPKEY,NIL))
    copystring(kp.startgamesound,Lt_GetAttributesA(mhandle,GAD_STARTGAME,NIL))
    copystring(kp.eatfruitsound,Lt_GetAttributesA(mhandle,GAD_EATFRUIT,NIL))
    copystring(kp.crashsound,Lt_GetAttributesA(mhandle,GAD_CRASH,NIL))
    kp.priority:=Lt_GetAttributesA(mhandle,GAD_PRI,NIL)
    kp.flags:=IF Lt_GetAttributesA(mhandle,GAD_LETHAL,NIL) THEN KPF_LETHAL180 ELSE 0
    kp.flags:=Or(kp.flags,IF Lt_GetAttributesA(mhandle,GAD_APPICON,NIL) THEN KPF_APPICON ELSE 0)
    kp.flags:=Or(kp.flags,IF Lt_GetAttributesA(mhandle,GAD_APPMENU,NIL) THEN KPF_APPMENU ELSE 0)

EXCEPT DO
    FOR a:=0 TO 6 DO IF image[a] THEN disposeImageData(image[a])
    IF cpen<>-1 THEN ReleasePen(mhandle.screen.viewport.colormap,cpen)
    IF mhandle THEN deleteMainWindow()
    IF mmenu THEN FreeMenus(mmenu)
    IF kp THEN KsWriteKRSNAkePrefs(kp)
    IF sample THEN KsDeleteSoundObject(sample)
    IF krsnakebase THEN CloseLibrary(krsnakebase)
    IF gtlayoutbase THEN CloseLibrary(gtlayoutbase)
    IF gadtoolsbase THEN CloseLibrary(gadtoolsbase)
    IF datatypesbase THEN CloseLibrary(datatypesbase)
    IF aslbase THEN CloseLibrary(aslbase)
    report_exception()
ENDPROC

PROC handleMenuPick(code)
    DEF menu,item,sub,t
    menu:=MENUNUM(code)
    item:=ITEMNUM(code)
    sub:=SUBNUM(code)
    SELECT menu
        CASE 0
            SELECT item
                CASE 0
                    REPEAT
                        t:=easyRequest('About KRSNAke 1.8',
                        VERSION +
                        '\nCopyright  1995 Psilocybe Software\n\n' +
                        'KRSNAke comes with ABSOLUTELY NO WARRANTY;\n' +
                        'for details click "Warranty".\n\n' +
                        'This is free software, and you are welcome\n' +
                        'to redistribute it under certain conditions;\n' +
                        'click "Conditions" for details.','Conditions|Warranty|OK',NIL)
                        SELECT t
                            CASE 2
                                easyRequest('KRSNAke 1.8 Warranty',
                                'This program is distributed in the hope that\n' +
                                'it will be useful, but WITHOUT ANY WARRANTY;\n' +
                                'without even the implied warranty of\n' +
                                'MERCHANTABILITY or FITNESS FOR A PARTICULAR\n' +
                                'PURPOSE. See the GNU General Public License\n' +
                                'for more details.\n','OK',NIL)
                            CASE 1
                                easyRequest('KRSNAke 1.8 Distribution Conditions',
                                'This program is free software; you can\n' +
                                'redistribute it and/or modify it under the\n' +
                                'terms of the GNU General Public License as\n' +
                                'published by the Free Software Foundation;\n' +
                                'either version 2 of the License, or (at your\n' +
                                'option) any later version.\n','OK',NIL)
                        ENDSELECT
                    UNTIL t=0
                CASE 2
                    RETURN TRUE
            ENDSELECT
    ENDSELECT
ENDPROC FALSE

PROC easyRequest(title,body,gads,arglist) IS EasyRequestArgs(mwin,
            [SIZEOF easystruct,0,title,body,gads],NIL,arglist)

PROC playSound(h,id)
    IF sample THEN KsDeleteSoundObject(sample)
    IF sample:=KsReadSoundObject(Lt_GetAttributesA(h,id,NIL)) THEN KsPlaySoundObject(sample)
ENDPROC

